// Copyright 2014 The Gogs Authors. All rights reserved.
// Copyright 2016 The Gitea Authors. All rights reserved.
// SPDX-License-Identifier: MIT

package main

import (
	"os"
	"runtime"
	"strings"
	"time"

	"code.mokoconsulting.tech/MokoConsulting/MokoGitea/cmd"
	"code.mokoconsulting.tech/MokoConsulting/MokoGitea/modules/log"
	"code.mokoconsulting.tech/MokoConsulting/MokoGitea/modules/setting"

	// register supported doc types
	_ "code.mokoconsulting.tech/MokoConsulting/MokoGitea/modules/markup/asciicast"
	_ "code.mokoconsulting.tech/MokoConsulting/MokoGitea/modules/markup/console"
	_ "code.mokoconsulting.tech/MokoConsulting/MokoGitea/modules/markup/csv"
	_ "code.mokoconsulting.tech/MokoConsulting/MokoGitea/modules/markup/markdown"
	_ "code.mokoconsulting.tech/MokoConsulting/MokoGitea/modules/markup/orgmode"

	"github.com/urfave/cli/v3"
)

// these flags will be set by the build flags
var (
	Version = "development" // program version for this build
	Tags    = ""            // the Golang build tags
)

func init() {
	setting.AppVer = Version
	setting.AppBuiltWith = formatBuiltWith()
	setting.AppStartTime = time.Now().UTC()
}

func main() {
	cli.OsExiter = func(code int) {
		log.GetManager().Close()
		os.Exit(code)
	}
	app := cmd.NewMainApp(cmd.AppVersion{Version: Version, Extra: formatBuiltWith()})
	_ = cmd.RunMainApp(app, os.Args...) // all errors should have been handled by the RunMainApp
	// flush the queued logs before exiting, it is a MUST, otherwise there will be log loss
	log.GetManager().Close()
}

func formatBuiltWith() string {
	version := runtime.Version()
	if len(Tags) == 0 {
		return " built with " + version
	}

	return " built with " + version + " : " + strings.ReplaceAll(Tags, " ", ", ")
}
